/*
 * This file contains modified code fragments from Cordova Qt QML file(s).
 * Modified by Sviox 2012.
 */

function CorvodaWrapper() {
    var me = this;
    var pluginObjects = {}


    this.callPluginFunction = function(pluginName, functionName, parameters) {
        //console.log("CorvodaWrapper::callPluginFunction() " + pluginName + ", " + functionName + ": " + parameters);  // Sviox
        parameters = eval("("+parameters+")")
        me.execMethodOld(pluginName, functionName, parameters)
    }

    this.callConfirm = function(message){
        if( confirm(message) )
            Notification.Callback(1);
        else
            Notification.Callback(2);
    }

    this.addPlugin = function(pluginName, pluginObject) {
        console.log("CorvodaWrapper::addPlugin() " + pluginName);
        pluginObjects[pluginName] = pluginObject
    }

    this.messageHandler = function(message) {
        var received = eval('('+message.data+')')
        if (typeof received == 'undefined')
            return false
        if (typeof received.messageType == 'undefined')
            return false
        if (received.messageType == "callPluginFunction") {
            if (typeof received.plugin == 'undefined' ||
                    typeof received.func == 'undefined')
                return false
            execMethod(received.plugin, received.func, received.params)
        }
        return true
    }


    this.execMethod = function(pluginName, functionName, params) {
        if( typeof pluginObjects[pluginName][functionName] != "function" )
            return false
        pluginObjects[pluginName][functionName].apply(this, params)
        return true
    }


    this.execMethodOld = function (pluginName, functionName, params) {
        if( typeof pluginObjects[pluginName][functionName] != "function" )
            return false

        var paramsString = JSON.stringify(params)
        if (paramsString.charAt(0) == "[")
            paramsString = paramsString.substring(1, paramsString.length-1)

        eval("pluginObjects[pluginName][functionName]("+paramsString+")")
        return true
    }

};

window.qmlWrapper = new CorvodaWrapper();
